t / test-lib.shon commit Add some fancy colors in the test library when terminal supports it. (55db1df)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5
   6# For repeatability, reset the environment to known value.
   7LANG=C
   8LC_ALL=C
   9PAGER=cat
  10TZ=UTC
  11export LANG LC_ALL PAGER TZ
  12EDITOR=:
  13VISUAL=:
  14unset GIT_EDITOR
  15unset AUTHOR_DATE
  16unset AUTHOR_EMAIL
  17unset AUTHOR_NAME
  18unset COMMIT_AUTHOR_EMAIL
  19unset COMMIT_AUTHOR_NAME
  20unset EMAIL
  21unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  22unset GIT_AUTHOR_DATE
  23GIT_AUTHOR_EMAIL=author@example.com
  24GIT_AUTHOR_NAME='A U Thor'
  25unset GIT_COMMITTER_DATE
  26GIT_COMMITTER_EMAIL=committer@example.com
  27GIT_COMMITTER_NAME='C O Mitter'
  28unset GIT_DIFF_OPTS
  29unset GIT_DIR
  30unset GIT_WORK_TREE
  31unset GIT_EXTERNAL_DIFF
  32unset GIT_INDEX_FILE
  33unset GIT_OBJECT_DIRECTORY
  34unset SHA1_FILE_DIRECTORIES
  35unset SHA1_FILE_DIRECTORY
  36GIT_MERGE_VERBOSITY=5
  37export GIT_MERGE_VERBOSITY
  38export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  39export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  40export EDITOR VISUAL
  41
  42# Protect ourselves from common misconfiguration to export
  43# CDPATH into the environment
  44unset CDPATH
  45
  46case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  47        1|2|true)
  48                echo "* warning: Some tests will not work if GIT_TRACE" \
  49                        "is set as to trace on STDERR ! *"
  50                echo "* warning: Please set GIT_TRACE to something" \
  51                        "other than 1, 2 or true ! *"
  52                ;;
  53esac
  54
  55# Each test should start with something like this, after copyright notices:
  56#
  57# test_description='Description of this test...
  58# This test checks if command xyzzy does the right thing...
  59# '
  60# . ./test-lib.sh
  61
  62[ "x$TERM" != "xdumb" ] &&
  63        tput bold >/dev/null 2>&1 &&
  64        tput setaf 1 >/dev/null 2>&1 &&
  65        tput sgr0 >/dev/null 2>&1 &&
  66        color=t
  67
  68test "${test_description}" != "" ||
  69error "Test script did not set test_description."
  70
  71while test "$#" -ne 0
  72do
  73        case "$1" in
  74        -d|--d|--de|--deb|--debu|--debug)
  75                debug=t; shift ;;
  76        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
  77                immediate=t; shift ;;
  78        -h|--h|--he|--hel|--help)
  79                echo "$test_description"
  80                exit 0 ;;
  81        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
  82                verbose=t; shift ;;
  83        --no-color)
  84            color=; shift ;;
  85        --no-python)
  86                # noop now...
  87                shift ;;
  88        *)
  89                break ;;
  90        esac
  91done
  92
  93if test -n "$color"; then
  94        say_color () {
  95                case "$1" in
  96                        error) tput bold; tput setaf 1;; # bold red
  97                        skip)  tput bold; tput setaf 2;; # bold green
  98                        pass)  tput setaf 2;;            # green
  99                        info)  tput setaf 3;;            # brown
 100                        *);;
 101                esac
 102                shift
 103                echo "* $*"
 104                tput sgr0
 105        }
 106else
 107        say_color() {
 108                shift
 109                echo "* $*"
 110        }
 111fi
 112
 113error () {
 114        say_color error "error: $*"
 115        trap - exit
 116        exit 1
 117}
 118
 119say () {
 120        say_color info "$*"
 121}
 122
 123exec 5>&1
 124if test "$verbose" = "t"
 125then
 126        exec 4>&2 3>&1
 127else
 128        exec 4>/dev/null 3>/dev/null
 129fi
 130
 131test_failure=0
 132test_count=0
 133
 134trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
 135
 136test_tick () {
 137        if test -z "${test_tick+set}"
 138        then
 139                test_tick=1112911993
 140        else
 141                test_tick=$(($test_tick + 60))
 142        fi
 143        GIT_COMMITTER_DATE="$test_tick -0700"
 144        GIT_AUTHOR_DATE="$test_tick -0700"
 145        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 146}
 147
 148# You are not expected to call test_ok_ and test_failure_ directly, use
 149# the text_expect_* functions instead.
 150
 151test_ok_ () {
 152        test_count=$(expr "$test_count" + 1)
 153        say_color "" "  ok $test_count: $@"
 154}
 155
 156test_failure_ () {
 157        test_count=$(expr "$test_count" + 1)
 158        test_failure=$(expr "$test_failure" + 1);
 159        say_color error "FAIL $test_count: $1"
 160        shift
 161        echo "$@" | sed -e 's/^/        /'
 162        test "$immediate" = "" || { trap - exit; exit 1; }
 163}
 164
 165
 166test_debug () {
 167        test "$debug" = "" || eval "$1"
 168}
 169
 170test_run_ () {
 171        eval >&3 2>&4 "$1"
 172        eval_ret="$?"
 173        return 0
 174}
 175
 176test_skip () {
 177        this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
 178        this_test="$this_test.$(expr "$test_count" + 1)"
 179        to_skip=
 180        for skp in $GIT_SKIP_TESTS
 181        do
 182                case "$this_test" in
 183                $skp)
 184                        to_skip=t
 185                esac
 186        done
 187        case "$to_skip" in
 188        t)
 189                say_color skip >&3 "skipping test: $@"
 190                test_count=$(expr "$test_count" + 1)
 191                say_color skip "skip $test_count: $1"
 192                : true
 193                ;;
 194        *)
 195                false
 196                ;;
 197        esac
 198}
 199
 200test_expect_failure () {
 201        test "$#" = 2 ||
 202        error "bug in the test script: not 2 parameters to test-expect-failure"
 203        if ! test_skip "$@"
 204        then
 205                say >&3 "expecting failure: $2"
 206                test_run_ "$2"
 207                if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
 208                then
 209                        test_ok_ "$1"
 210                else
 211                        test_failure_ "$@"
 212                fi
 213        fi
 214        echo >&3 ""
 215}
 216
 217test_expect_success () {
 218        test "$#" = 2 ||
 219        error "bug in the test script: not 2 parameters to test-expect-success"
 220        if ! test_skip "$@"
 221        then
 222                say >&3 "expecting success: $2"
 223                test_run_ "$2"
 224                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 225                then
 226                        test_ok_ "$1"
 227                else
 228                        test_failure_ "$@"
 229                fi
 230        fi
 231        echo >&3 ""
 232}
 233
 234test_expect_code () {
 235        test "$#" = 3 ||
 236        error "bug in the test script: not 3 parameters to test-expect-code"
 237        if ! test_skip "$@"
 238        then
 239                say >&3 "expecting exit code $1: $3"
 240                test_run_ "$3"
 241                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
 242                then
 243                        test_ok_ "$2"
 244                else
 245                        test_failure_ "$@"
 246                fi
 247        fi
 248        echo >&3 ""
 249}
 250
 251# Most tests can use the created repository, but some amy need to create more.
 252# Usage: test_create_repo <directory>
 253test_create_repo () {
 254        test "$#" = 1 ||
 255        error "bug in the test script: not 1 parameter to test-create-repo"
 256        owd=`pwd`
 257        repo="$1"
 258        mkdir "$repo"
 259        cd "$repo" || error "Cannot setup test environment"
 260        "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
 261        error "cannot run git init -- have you built things yet?"
 262        mv .git/hooks .git/hooks-disabled
 263        cd "$owd"
 264}
 265
 266test_done () {
 267        trap - exit
 268        case "$test_failure" in
 269        0)
 270                # We could:
 271                # cd .. && rm -fr trash
 272                # but that means we forbid any tests that use their own
 273                # subdirectory from calling test_done without coming back
 274                # to where they started from.
 275                # The Makefile provided will clean this test area so
 276                # we will leave things as they are.
 277
 278                say_color pass "passed all $test_count test(s)"
 279                exit 0 ;;
 280
 281        *)
 282                say_color error "failed $test_failure among $test_count test(s)"
 283                exit 1 ;;
 284
 285        esac
 286}
 287
 288# Test the binaries we have just built.  The tests are kept in
 289# t/ subdirectory and are run in trash subdirectory.
 290PATH=$(pwd)/..:$PATH
 291GIT_EXEC_PATH=$(pwd)/..
 292GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
 293GIT_CONFIG=.git/config
 294export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG
 295
 296GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
 297export GITPERLLIB
 298test -d ../templates/blt || {
 299        error "You haven't built things yet, have you?"
 300}
 301
 302if ! test -x ../test-chmtime; then
 303        echo >&2 'You need to build test-chmtime:'
 304        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 305        exit 1
 306fi
 307
 308# Test repository
 309test=trash
 310rm -fr "$test"
 311test_create_repo $test
 312cd "$test"
 313
 314this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
 315for skp in $GIT_SKIP_TESTS
 316do
 317        to_skip=
 318        for skp in $GIT_SKIP_TESTS
 319        do
 320                case "$this_test" in
 321                $skp)
 322                        to_skip=t
 323                esac
 324        done
 325        case "$to_skip" in
 326        t)
 327                say_color skip >&3 "skipping test $this_test altogether"
 328                say_color skip "skip all tests in $this_test"
 329                test_done
 330        esac
 331done